// DlgPreview.cpp : implementation file
//

#include "stdafx.h"
#include "TEST.h"
#include "DlgPreview.h"
#include "TESTDlg.h"

#include <wtypes.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgPreview dialog


CDlgPreview::CDlgPreview(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPreview::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPreview)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgPreview::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPreview)
	DDX_Control(pDX, IDC_AXVIEWER, m_stAxViewer);
	DDX_Control(pDX, IDC_VIDEO_STARTSTOP, m_video_startstop);
	DDX_Control(pDX, IDC_VIDEO_MPEG4MJPEG, m_video_mpeg4mjpeg);
	DDX_Control(pDX, IDC_AUDIO_MIC_STARTSTOP, m_audio_mic_startstop);
	DDX_Control(pDX, IDC_AUDIO_SPK_STARTSTOP, m_audio_spk_startstop);
	DDX_Control(pDX, IDC_BTN_SNAPSHOT, m_snapshot);
	DDX_Control(pDX, IDC_RECORD_STARTSTOP, m_record_startstop);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgPreview, CDialog)
	//{{AFX_MSG_MAP(CDlgPreview)
	ON_BN_CLICKED(IDC_VIDEO_STARTSTOP, OnVideo1Startstop)
	ON_BN_CLICKED(IDC_VIDEO_MPEG4MJPEG, OnVideo1Mpeg4mjpeg)
	ON_BN_CLICKED(IDC_AUDIO_MIC_STARTSTOP, OnAudio1MicStartstop)
	ON_BN_CLICKED(IDC_AUDIO_SPK_STARTSTOP, OnAudio1SpkStartstop)
	ON_BN_CLICKED(IDC_RECORD_STARTSTOP, OnRecord1Startstop)
	ON_BN_CLICKED(IDC_BTN_WIDE, OnBtnWide)
	ON_BN_CLICKED(IDC_BTN_TELE, OnBtnTele)
	ON_BN_CLICKED(IDC_BTN_LUP, OnBtnLup)
	ON_BN_CLICKED(IDC_BTN_U, OnBtnU)
	ON_BN_CLICKED(IDC_BTN_RUP, OnBtnRup)
	ON_BN_CLICKED(IDC_BTN_LEFT, OnBtnLeft)
	ON_BN_CLICKED(IDC_BTN_CENTER, OnBtnCenter)
	ON_BN_CLICKED(IDC_BTN_RIGHT, OnBtnRight)
	ON_BN_CLICKED(IDC_BTN_LDOWN, OnBtnLdown)
	ON_BN_CLICKED(IDC_BTN_DOWN, OnBtnDown)
	ON_BN_CLICKED(IDC_BTN_RDOWN, OnBtnRdown)
	ON_BN_CLICKED(IDC_BTN_SNAPSHOT, OnBtnSnapshot)
	ON_BN_CLICKED(IDC_BTN_PTZ_LUP, OnBtnPtzLup)
	ON_BN_CLICKED(IDC_BTN_PTZ_U, OnBtnPtzU)
	ON_BN_CLICKED(IDC_BTN_PTZ_RUP, OnBtnPtzRup)
	ON_BN_CLICKED(IDC_BTN_PTZ_LEFT, OnBtnPtzLeft)
	ON_BN_CLICKED(IDC_BTN_PTZ_CENTER, OnBtnPtzCenter)
	ON_BN_CLICKED(IDC_BTN_PTZ_RIGHT, OnBtnPtzRight)
	ON_BN_CLICKED(IDC_BTN_PTZ_LDOWN, OnBtnPtzLdown)
	ON_BN_CLICKED(IDC_BTN_PTZ_DOWN, OnBtnPtzDown)
	ON_BN_CLICKED(IDC_BTN_PTZ_RDOWN, OnBtnPtzRdown)
	ON_BN_CLICKED(IDC_BTN_PTZ_ZOOM_OUT, OnBtnPtzZoomOut)
	ON_BN_CLICKED(IDC_BTN_PTZ_ZOOM_IN, OnBtnPtzZoomIn)
	ON_BN_CLICKED(IDC_BTN_PTZ_FOCUS_FAR, OnBtnPtzFocusFar)
	ON_BN_CLICKED(IDC_BTN_PTZ_FOCUS_NEAR, OnBtnPtzFocusNear)
	ON_BN_CLICKED(IDC_BTN_FULLSCREEN, OnBtnFullscreen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPreview message handlers

BOOL CDlgPreview::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_ViewerPreview = NULL;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDlgPreview::OnVideo1Startstop() 
{
	SetStartViewer(&m_ViewerPreview, 1, &m_video_startstop, &m_video_mpeg4mjpeg, &m_audio_mic_startstop, &m_audio_spk_startstop, &m_snapshot, &m_record_startstop);
	
}

void CDlgPreview::OnVideo1Mpeg4mjpeg() 
{
    static int Mpeg4mjpeg=1;

	if(m_ViewerPreview)
    {
        Mpeg4mjpeg++;
	    m_ViewerPreview->ChangeVideoMode(Mpeg4mjpeg%2);
        if(Mpeg4mjpeg%2)
            m_video_mpeg4mjpeg.SetWindowText("MJPEG");
        else
            m_video_mpeg4mjpeg.SetWindowText("MPEG4");
    }
}

void CDlgPreview::OnAudio1MicStartstop() 
{
    static int MicStartstop=0;

	if(m_ViewerPreview)
    {
        MicStartstop++;
	    m_ViewerPreview->TalkEnable(MicStartstop%2);
        if(MicStartstop%2)
            m_audio_mic_startstop.SetWindowText("Mic Off");
        else
            m_audio_mic_startstop.SetWindowText("Mic On");
    }
}

void CDlgPreview::OnAudio1SpkStartstop() 
{
    static int SpkStartstop=0;

	if(m_ViewerPreview)
    {
        SpkStartstop++;
	    m_ViewerPreview->AudioStart(SpkStartstop%2);
        if(SpkStartstop%2)
            m_audio_spk_startstop.SetWindowText("Speaker Off");
        else
            m_audio_spk_startstop.SetWindowText("Speaker On");
    }
}

void CDlgPreview::OnRecord1Startstop() 
{
    static int Record1Startstop=0;
    CTESTDlg* pwndParent = (CTESTDlg*) (GetParent()->GetParent());
    pwndParent->UpdateData();
    
    if(pwndParent->m_strSavePath != _T(""))
    {
	    if(m_ViewerPreview)
        {
            Record1Startstop++;
            m_ViewerPreview->SetRecordPath(pwndParent->m_strSavePath);
	        m_ViewerPreview->RecordStart(Record1Startstop%2);
            if(Record1Startstop%2)
                m_record_startstop.SetWindowText("Stop");
            else
                m_record_startstop.SetWindowText("Start");
        }
    }
}

void CDlgPreview::OnBtnSnapshot() 
{
    CTESTDlg* pwndParent = (CTESTDlg*) (GetParent()->GetParent());
    pwndParent->UpdateData();
    
    if(pwndParent->m_strSavePath != _T(""))
    {
        SYSTEMTIME pTime;
	    char picPath[256];
	    char picPathName[256];
        GetSystemTime(&pTime);
        _tcscpy(picPath, pwndParent->m_strSavePath);
        sprintf(picPathName, "%s%04d%02d%02d%02d%02d%02d.jpg", picPath, pTime.wYear, pTime.wMonth, pTime.wDay, 
                                                                        pTime.wHour, pTime.wMinute, pTime.wSecond);
	    if(m_ViewerPreview)
        {
            m_ViewerPreview->SetSnapshotPathName(picPathName);
            m_ViewerPreview->Snapshot();
        }
    }

}

void CDlgPreview::SetStartViewer(CAxViewer **m_Viewer, int ch, 
                              CButton *button_video_startstop, 
                              CButton *button_video_mpeg4mjpeg,
                              CButton *button_audio_mic_startstop,
                              CButton *button_audio_spk_startstop,
                              CButton *button_snapshot,
                              CButton *button_record_startstop) 
{
	if(*m_Viewer == NULL){

		/*if(m_ConnectInfo.DoModal() != IDOK)
		return;
        
		if(strlen(m_ConnectInfo.m_user) == 0){
			AfxMessageBox("Invalid ID");
			return;
		}
		if(strlen(m_ConnectInfo.m_passwd) == 0){
			AfxMessageBox("Invalid Password");
			return;
		}
		
		if(strlen(m_ConnectInfo.m_ipaddress) == 0){
			AfxMessageBox("Invalid Host Address");
			return;
		}*/

        CTESTDlg* pwndParent = (CTESTDlg*) (GetParent()->GetParent());
        pwndParent->UpdateData();
		*m_Viewer = new CAxViewer;				

        CRect rcAxViewer,rcTabCtrl;
        m_stAxViewer.GetClientRect(&rcAxViewer);
        rcAxViewer.top+=4;
        rcAxViewer.bottom+=4;
        rcAxViewer.left+=25;
        rcAxViewer.right+=25;

		(*m_Viewer)->Create(NULL,WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, rcAxViewer,this,100);		
		/*(*m_Viewer)->SetHttpPort(m_ConnectInfo.m_http_port);	
		(*m_Viewer)->SetHostIP(m_ConnectInfo.m_ipaddress);
		(*m_Viewer)->SetUserName(m_ConnectInfo.m_user);
		(*m_Viewer)->SetPassword(m_ConnectInfo.m_passwd);*/
        
		(*m_Viewer)->SetHostIP(pwndParent->m_edIP);
		(*m_Viewer)->SetUserName(pwndParent->m_edUser);
		(*m_Viewer)->SetPassword(pwndParent->m_edPass);
        (*m_Viewer)->SetHttpPort(pwndParent->m_http_port);
	
		(*m_Viewer)->AVConnect(1);
		(*m_Viewer)->VideoStart(1);
	
		button_video_startstop->SetWindowText("Stop");
        
		button_video_mpeg4mjpeg->EnableWindow(TRUE);
		button_audio_mic_startstop->EnableWindow(TRUE);
		button_audio_spk_startstop->EnableWindow(TRUE);
		button_snapshot->EnableWindow(TRUE);
		button_record_startstop->EnableWindow(TRUE);

		Sleep(1000);
	}else{
		(*m_Viewer)->AVConnect(0);
		(*m_Viewer)->VideoStart(0);
		delete *m_Viewer;
		*m_Viewer = NULL;

		//ĸǹٲٱ 		
		button_video_startstop->SetWindowText("Start");

		button_video_mpeg4mjpeg->EnableWindow(FALSE);
		button_audio_mic_startstop->EnableWindow(FALSE);
		button_audio_spk_startstop->EnableWindow(FALSE);
		button_snapshot->EnableWindow(FALSE);
		button_record_startstop->EnableWindow(FALSE);
	}	
}



void CDlgPreview::OnBtnFullscreen() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->SetFullScreen(TRUE);
}

void CDlgPreview::OnBtnWide() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomOut();
}

void CDlgPreview::OnBtnTele() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomIn();
}

void CDlgPreview::OnBtnLup() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(1);
}

void CDlgPreview::OnBtnU() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(2);
}

void CDlgPreview::OnBtnRup() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(3);
}

void CDlgPreview::OnBtnLeft() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(4);
}

void CDlgPreview::OnBtnCenter() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(5);
}

void CDlgPreview::OnBtnRight() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(6);
}

void CDlgPreview::OnBtnLdown() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(7);
}

void CDlgPreview::OnBtnDown() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(8);
}

void CDlgPreview::OnBtnRdown() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->VideoDZoomMove(9);
}

void CDlgPreview::OnBtnPtzLup() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(1, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzU() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(2, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzRup() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(3, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzLeft() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(4, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzCenter() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(5, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzRight() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(6, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzLdown() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(7, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzDown() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(8, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzRdown() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(9, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzZoomIn() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(10, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzZoomOut() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(11, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzFocusFar() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(12, _T(""), 0, 0);
}

void CDlgPreview::OnBtnPtzFocusNear() 
{
	if(m_ViewerPreview)
        m_ViewerPreview->PTZCommand(13, _T(""), 0, 0);
}
